<?php


namespace Controller;

use Traits\TResponse;
use Util\InstanceProvider;
use Util\Utilities;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class ValoresOrcaCli
{
    use TResponse;

    /**
     * @var \Service\ValoresOrcaCli
     */
    private $valoresorcacliService;

    public function __construct(\Service\ValoresOrcaCli $valoresorcacliService)
    {
        $this->valoresorcacliService = $valoresorcacliService;
    }

    public function saveNrParcelaValoresOrcaClie(Request $request, Response $response)
    {
        try {
            $rows = $request->getParameter('ROWS');
            $actions = $this->valoresorcacliService->saveNrParcelaValoresOrcaClie($rows);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function qryVigencia(Request $request, Response $response)
    {
        try {
            $cdcliente = $request->getParameter('CDCLIENTE');
            $actions = $this->valoresorcacliService->qryVigencia($cdcliente);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function qryItemOrca(Request $request, Response $response)
    {
        try {
            $param = $request->getParameters();
            $cdcliente = $param['CDCLIENTE'];
            $dtinivaitorc = empty($param['DTINIVAITORC']) ? null : $param['DTINIVAITORC'];
            $actions = $this->valoresorcacliService->qryItemOrca($cdcliente, $dtinivaitorc);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function qryDelItemOrca(Request $request, Response $response)
    {
        try {
            $rows = $request->getParameter('ROWS');
            $actions = $this->valoresorcacliService->qryDelItemOrca($rows);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveValoresOrcaCliTab(Request $request, Response $response)
    {
        try {
            $dtinivaitorc =  $request->getParameter('DTINIVAITORC');
            $cdcliente = $request->getParameter('CDCLIENTE');
            $itens = $request->getParameter('ITENS');
            $actions = $this->valoresorcacliService->saveValoresOrcaCliTab($dtinivaitorc, $cdcliente, $itens);
            $this->sendResponse($actions, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
