<?php

namespace Repository;

use Util\InstanceProvider;
use Teknisa\Model\Traits\TQuery;

class Resource
{
    use TQuery;

    public function getEntityManager(){
        return InstanceProvider::getEntityManager();
    }

    public function findAllEmployeeTaskTracking($organizationId){

        $query = <<<SQL
		SELECT ID,NAME ,STRUCTURE_NAME, RESOURCE_STATUS FROM (
			  SELECT RES.*,PER.STRUCTURE, STR.NAME AS STRUCTURE_NAME, (CASE WHEN RES.STATUS = 'A' THEN 'Ativo' ELSE 'Inativo' END ) AS RESOURCE_STATUS
				FROM RESOURCE_T RES
           LEFT JOIN PERMISSION PER ON (PER.RESOURCE_T = RES.ID AND NVL(PER.TYPE,'R') = 'R' )
           LEFT JOIN STRUCTURE STR ON (STR.ID = PER.STRUCTURE )
               WHERE RES.ORGANIZATION = :organizationId
				 AND RES.CLASS = 'E')
			   WHERE 1=1
				GROUP BY ID, NAME, STRUCTURE_NAME, RESOURCE_STATUS
				ORDER BY NAME
SQL;

        $param = array(
            'organizationId' => $organizationId
        );
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $param);
    }

    public function findAllStructureManagersTaskTracking($organizationId, $filters = '') {
		$query = <<<SQL
		SELECT * FROM (
              SELECT BP.ID, BP.NAME
				FROM RESOURCE_T BP
				JOIN PERMISSION PER ON (PER.RESOURCE_T = BP.ID AND PER.TYPE = 'M')
			   WHERE BP.ORGANIZATION = :organizationId
                 AND BP.RESOURCES_TYPE = 'W'
            GROUP BY BP.ID,BP.NAME
            ORDER BY BP.NAME)
            WHERE 1 = 1
             $filters
SQL;

		$params = array(
			'organizationId' => $organizationId
		);

		return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);
	}
}
