import { ITekConfig } from '@zeedhi/teknisa-components-common';
import prodEnvironment from './prodEnvironment.json';
import devEnvironment from './devEnvironment.json';

const env = process.env.NODE_ENV === 'production' ? prodEnvironment : devEnvironment;

const config: ITekConfig = {
	endPoint: env.endPoint,
	metadataEndPoint: env.metadataEndPoint,
	dateFormat: 'YYYY-MM-DD',
	displayFormat: 'DD/MM/YYYY',
	saveGridLayoutsEndPoint: 'lib_saveLayout',
	loadGridLayoutsEndPoint: 'lib_loadLayout',

	datasourceArrayFormat: 'indices',
	env: {
		product: env.product,
		baseUrl: env.baseUrl,
		modules: env.modules,
		urlWebSocket: env.urlWebSocket,
		endPoint: env.endPoint,
		loginRoutePath: env.modules.login.routePath,
		loginBackgroundImgUrl: env.modules.login.backgroundImgUrl,
		loginEndPoint: env.modules.login.endPoint,
	},
};

export default config;
